#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
void solve();
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t=1;
    //cin>>t;
    while(t--) {solve();}
    return 0;
}

//#define int long long
const int INF = 2e9;
const int MOD = 1e9 + 7;
const int MAXN = 2e2;
const int K = 22;

int dp[MAXN][(1 << K)];

void solve() {
    int n, k;
    cin>>n>>k;
    vector<int> b(n);

    int s = k * (k+1)/2;
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        if (b[i] > s) {
            cout << 0;
            return;
        }
    }
    if (b[0] > k) {
        cout << 0;
        return;
    }
    for (int mask = 0; mask < (1 << k); mask++) {
        int now = 0;
        for (int i = 0; i < k; i++) {
            if (mask & (1 << i)) {
                now++;
            }
        }
        if (now == b[0]) {
            dp[0][mask << (s-k)]=1;
        }
    }
    for (int i = 1; i < n; i++) {
        for (int mask = 0; mask < (1 << s); mask++) {
            int now = 0;
            for (int j = 0; j < s; j++) {
                if (mask & (1 << j)) {
                    now++;
                }
            }
            if (now != b[i]) continue;
            for (int _mask = 0; _mask < (1 << s); _mask++) {
                bool f = true;
                for (int kk = max((int)1, k-i); kk <k ; kk++) {
                    for (int j = (kk-1) * (kk)/2; j < (kk) * (kk +1)/2; j++) {
                        bool bit1 = _mask & (1 << (j+kk));
                        bool bit2 = mask & (1 << j);
                        if (bit1 != bit2) {
                            f = false;
                            break;
                        }
                    }
                }
                if (f) {
                    dp[i][mask] += dp[i-1][_mask];
                    dp[i][mask] %= MOD;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < (1 << s); i++) {
        ans += dp[n-1][i];
        ans %= MOD;
    }
    cout << ans;
}