#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
void solve();
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t=1;
    //cin>>t;
    while(t--) {solve();}
    return 0;
}

#define int long long
const int INF = 2e18;
const int MOD = 1e9 + 7;
const int MAXN = 1e5;
struct T {
    int x, add;
};


T tre[MAXN * 4];
pair<int,int> tre1[MAXN * 4];
pair<int,int> tre2[MAXN * 4];
int h[MAXN];

void build(int t, int l, int r) {
    if  (r - l == 1) {
        tre[t].x = h[l];
        tre1[t] = {h[l],l};
        tre2[t] = {h[l],l};
        return;
    }
    int m = (r + l)/2;
    build(t * 2,l,m);
    build(t * 2 + 1,m,r);
    tre[t].x = tre[t * 2].x + tre[t * 2 + 1].x;
    tre1[t] = max(tre1[t * 2],tre1[t * 2 + 1]);
    if (tre2[t*2].first >= tre2[t * 2+1].first) {
        tre2[t] = tre2[t *2];
    } else if (tre2[t * 2].first < tre2[t * 2 + 1].first) {
        tre2[t] = tre2[t * 2 + 1];
    }
}

void push(int t, int l, int m, int r) {
    if (tre[t].add != 0) {
        tre[t * 2].x = tre[t].add * (m-l);
        tre[t * 2 + 1].x = tre[t].add * (r-m);
        tre[t*2].add=tre[t].add;
        tre[t * 2 + 1].add = tre[t].add;
        tre[t].add=0;
    }
}

void sett(int t, int l, int r, int tl, int tr, int x) {
    if (tl>=l && tr <=r) {
        tre[t].x = x * (tr-tl);
        tre[t].add= x;
        return;
    }
    if (tl >= r || tr <= l) {
        return;
    }
    int m =(tl + tr)/2;
    push(t,tl,m,tr);
    sett(t * 2,l,r,tl,m,x);
    sett(t * 2 + 1,l,r,m,tr,x);
    tre[t].x = tre[t * 2].x + tre[t * 2 + 1].x;
}

int get(int t, int l, int r, int tl, int tr) {
    if (tl >= l && tr <= r) {
        return tre[t].x;
    }
    if (tl >= r || tr <= l) {
        return 0;
    }
    int m = (tl + tr)/2;
    push(t,tl,m,tr);
    return get(t * 2,l,r,tl,m) + get(t * 2 + 1,l,r,m,tr);
}

pair<int,int> getmxr (int t, int l, int r, int tl, int tr) {
    if (tl >= l && tr <= r) {
        return tre1[t];
    }
    if (tl >= r || tr <= l) {
        return {-INF, -INF};
    }
    int m = (tl + tr)/2;
    return max(getmxr(t * 2,l,r,tl,m), getmxr(t * 2 + 1,l,r,m,tr));
}

pair<int,int> getmxl (int t, int l, int r, int tl, int tr) {
    if (tl >= l && tr <= r) {
        return tre2[t];
    }
    if (tl >= r || tr <= l) {
        return {-INF, -INF};
    }
    int m = (tl + tr)/2;
    auto x1 = getmxl(t * 2,l,r,tl,m);
    auto x2 = getmxl(t * 2 + 1,l,r,m,tr);
    if (x1.first >= x2.first) {
        return x1;
    } else {
        return x2;
    }
}


void solve() {
    int n;
    cin >> n;
    vector<int> pref(n + 1);
    ordered_set<pair<int,int>> st;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1]=pref[i] + h[i];
        st.insert({i,i});
    }
    build(1,0,n);
    vector<int> l(n);
    vector<int> r(n);
    vector<pair<int,int>> sta = {{INF, -1}};
    for (int i = 0; i < n; i++) {
        while (!sta.empty() && h[i] > sta.back().first) {
            sta.pop_back();
        }
        l[i] = sta.back().second;
        sta.push_back({h[i],i});
    }
    sta = {{INF, n}};
    for (int i = n-1; i >= 0; i--) {
        while (!sta.empty() && h[i] > sta.back().first) {
            sta.pop_back();
        }
        r[i] = sta.back().second;
        sta.push_back({h[i],i});
    }
    int q = n-1;
    while (q--) {
        int k;
        cin >> k;
        k--;
        auto x = *st.find_by_order(k);
        auto y = *st.find_by_order(k + 1);
        auto mxl = getmxr(1,x.first,x.second+1,0,n);
        auto mxr = getmxl(1,y.first,y.second+1,0,n);
        int mn = min(mxl.first,mxr.first);
        if (mxl.first <= mxr.first) {
            sett(1,mxl.second+1,r[mxl.second],0,n,mn);
        } else {
            sett(1,l[mxr.second]+1,mxr.second,0,n,mn);
        }
        int ans = get(1,x.first,y.second+1,0,n);
        ans -= pref[y.second + 1] - pref[x.first];
        cout << ans << '\n';
        st.erase(st.lower_bound(x));
        st.erase(st.lower_bound(y));
        st.insert({x.first,y.second});
    }
}